Bug 156156 - Add Help button to sidebar
Summary: Add Help button to sidebar
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
4.1.0.4 release
Hardware: All All
: medium enhancement
Assignee: Rafael Lima
URL:
Whiteboard: target:24.2.0 target:24.8.0 target:24...
Keywords:
Depends on:
Blocks: Sidebar Help-Link
  Show dependency treegraph
 
Reported: 2023-07-04 14:09 UTC by Stéphane Guillou (stragu)
Modified: 2024-06-25 16:49 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments
suggested UI: question mark next to close cross (106.69 KB, image/png)
2023-07-04 14:09 UTC, Stéphane Guillou (stragu)
Details
tetsting patchset 7 from gerrit#154918 (43.62 KB, image/png)
2023-07-27 08:55 UTC, Stéphane Guillou (stragu)
Details
alternate approach to adding ? to deck toolbox for deck help (74.71 KB, image/png)
2023-08-06 05:23 UTC, Jim Raykowski
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Stéphane Guillou (stragu) 2023-07-04 14:09:51 UTC
Created attachment 188207 [details]
suggested UI: question mark next to close cross

The sidebar gets more and more features, and some functionalities are even only available there and not duplicated in another dialog (e.g. the Accessibility Check deck).
To access the corresponding Help page, one has to know about the F1 shortcut.

To increase accessibility to and visibility of the Sidebar decks' documentation, I suggest adding a button in each deck. It can be very discrete, for example a small question mark next to the Close Sidebar Deck cross.

Checked in:

Version: 24.2.0.0.alpha0+ (X86_64) / LibreOffice Community
Build ID: ec60d354359067f8c5c686ef2239ee705916de43
CPU threads: 8; OS: Linux 5.15; UI render: default; VCL: gtk3
Locale: en-AU (en_AU.UTF-8); UI: en-US
Calc: threaded

Same in OOo 3.3, so inherited.
Comment 1 V Stuart Foote 2023-07-04 16:01:55 UTC
+1

But doing the UI work across the SB decks would only be a first step. Assigning the appropriate linkage for each panel (or authoring missing pages) will need effort from the Documentation team.
Comment 2 Stéphane Guillou (stragu) 2023-07-05 13:01:40 UTC
Thanks Stuart.
Someone could do an initial commit to demonstrate the process for a single deck, and leaving this open as an easyHack. But I'm not too keen on having a lingering inconsistent UI waiting for contributors.

(Just for the record, I marked as inherited because OOo 3.3 could open the Styles and Formatting help page by pressing F1 when the docked panel was focused, but it didn't have a button either. Same for the Tasks panel in Impress.)
Comment 3 Heiko Tietze 2023-07-05 13:52:03 UTC
The deck title bar is handled in sfx2/source/sidebar/Deck.cxx for every deck. Adding another toolbutton in sfx2/uiconfig/ui/deck.ui is easy and maybe Jim or Andreas figures out how to connect help ids to the button. Maybe in sfx2/source/sidebar/SidebarController.cxx.
Comment 4 Rafael Lima 2023-07-26 00:12:42 UTC
This patch adds a Help button to the sidebar deck, so that each deck has its own Help ID, which can later be used as reference to write help pages:

https://gerrit.libreoffice.org/c/core/+/154918
Comment 5 Stéphane Guillou (stragu) 2023-07-27 08:55:44 UTC
Created attachment 188586 [details]
tetsting patchset 7 from gerrit#154918

I commented on gerrit, but also putting it here for Rafael's work-in-progress:

- keyboard navigation: the question mark is reachable but I can't reach the cross anymore.
- the width of the question mark is very small, making it hard to click, and the character goes lower than the cross (only cosmetic). I agree that an icon would be better, using the same aspect ratio than the cross. But that can be done in a follow-up commit if needed, maybe pinging Rizal.
- button leads to 404s on the Help website, but sorting out the HIDs can also be done later
Comment 6 Commit Notification 2023-08-04 22:06:30 UTC
Rafael Lima committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/9ca60dc90958001c078ed6331bd432c36961a425

tdf#156156 Add Help button to sidebar decks

It will be available in 24.2.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 7 Jim Raykowski 2023-08-06 05:23:58 UTC
Created attachment 188801 [details]
alternate approach to adding ? to deck toolbox for deck help

I'd like to suggest an alternative approach to the ? addition to the deck toolbox. Instead, add a menu item, 'Help...' or 'Deck Help...' in the Tabbar hamburger menu.
Comment 8 Rafael Lima 2023-08-06 20:31:56 UTC
(In reply to Jim Raykowski from comment #7)
> I'd like to suggest an alternative approach to the ? addition to the deck
> toolbox. Instead, add a menu item, 'Help...' or 'Deck Help...' in the Tabbar
> hamburger menu.

This looks nice too. It is important that clicking "Help" will redirect to a HID that corresponds to the selected deck.

Just a note... the current "?" character will be replaced by an actual icon to improve the appearance. However I still haven't created the ticket to request said icon.

Now from a UX/a11y standpoint I don't know which approach is best. But I think we should have either the "Help" entry in the hamburger menu or the "?" button... having both would be too much.
Comment 9 Jim Raykowski 2023-08-06 21:26:26 UTC
(In reply to Rafael Lima from comment #8)
> Just a note... the current "?" character will be replaced by an actual icon
> to improve the appearance. However I still haven't created the ticket to
> request said icon.
Yes, I think an icon would improve the appearance, especially for gtk3. 

> Now from a UX/a11y standpoint I don't know which approach is best. But I
> think we should have either the "Help" entry in the hamburger menu or the
> "?" button... having both would be too much.
I agree, one or the other, not both.
Comment 10 Rafael Lima 2023-08-06 21:38:50 UTC
(In reply to Jim Raykowski from comment #9)
> I agree, one or the other, not both.

I have to admit that your proposal looks cleaner. I would suggest the text be something other than simply "Help" to not confuse the user the About - Help entry in the main menu... maybe "Help about this deck" (although this is too verbose).
Comment 11 Rafael Lima 2023-08-08 12:07:17 UTC
In any case, here's the request for the "?" button to improve the design of the new help button (see bug 156671).
Comment 12 Commit Notification 2023-12-19 02:58:40 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/help/commit/a08e4de6931f915b708a749d82d841bf0f6a8032

tdf#156156: add Gallery sidebar deck help button's HID
Comment 13 Stéphane Guillou (stragu) 2023-12-19 10:17:22 UTC
@Rafael and @Olivier

I'm looking at linking to the Help pages currently.
The Help ID constructor in https://opengrok.libreoffice.org/xref/core/sfx2/source/sidebar/ResourceManager.cxx?r=9ca60dc9#281 is good for most cases, but sometimes it would be useful to differentiate between components, for example the Styles deck:
- In Impress, it should go to https://help.libreoffice.org/24.8/en-US/text/simpress/01/05100000.html
- In Writer, it should go to https://help.libreoffice.org/24.8/en-US/text/swriter/01/05140000.html

Same thing, for example, for the Navigator.

What's the best solution in your opinion?
Comment 14 Commit Notification 2023-12-19 12:23:20 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "libreoffice-24-2":

https://git.libreoffice.org/help/commit/73dea49d1b3d37f1091319cddcfddd8da7031921

tdf#156156: add Gallery sidebar deck help button's HID
Comment 15 Commit Notification 2023-12-19 12:24:23 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/help/commit/64d940a42d41a4b77deacbfdb344cecf94975cf4

tdf#156156: add Accessibility Check sidebar deck help button's HID
Comment 16 Commit Notification 2023-12-19 19:01:36 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "libreoffice-24-2":

https://git.libreoffice.org/help/commit/c85f8568c91481d09e5adbed8d961df58843dad5

tdf#156156: add Accessibility Check sidebar deck help button's HID
Comment 17 Commit Notification 2023-12-19 19:02:39 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/help/commit/8d2a9b80fbb89596185c5b6863713eb696af7140

tdf#156156: add Inspector and Functions sidebar decks help button's HID
Comment 18 Commit Notification 2023-12-21 13:32:17 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "libreoffice-24-2":

https://git.libreoffice.org/help/commit/3c6d3a4e3dbc6ab35d76d43032114a637d9288d6

tdf#156156: add Inspector and Functions sidebar decks help button's HID
Comment 19 Commit Notification 2023-12-21 18:05:01 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/help/commit/05f08bd00aadd36088254d7fe062507fea113de8

tdf#156156: add Manage Changes sidebar decks help button's HID
Comment 20 Commit Notification 2023-12-22 22:07:19 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/help/commit/35b84bc686dc7e5aed86394e1896432aeeb68865

tdf#156156: add Animation sidebar deck help button's HID
Comment 21 Commit Notification 2024-01-04 20:46:56 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/help/commit/c8244945b9d36822a2a35edca7bb9111f39ef282

tdf#156156: add Slide Transition sidebar deck help button's HID
Comment 22 Commit Notification 2024-01-13 19:18:53 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "libreoffice-24-2":

https://git.libreoffice.org/help/commit/d529ecdee07d04f261fd13d05ecf2e0ee9f18a4b

tdf#156156: add Slide Transition sidebar deck help button's HID
Comment 23 Commit Notification 2024-01-22 12:54:21 UTC
Christian Lohmaier committed a patch related to this issue.
It has been pushed to "libreoffice-24-2":

https://git.libreoffice.org/help/commit/2b0885774389f5bc85cc697294f05212f44d2392

Revert "tdf#156156: add Slide Transition sidebar deck help button's HID"
Comment 24 Commit Notification 2024-03-12 10:57:55 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "libreoffice-24-2":

https://git.libreoffice.org/help/commit/fd026c4fce76473afbb92d7a5098d0e9af152517

tdf#156156: add Manage Changes sidebar decks help button's HID
Comment 25 Commit Notification 2024-03-12 10:57:58 UTC
Stéphane Guillou committed a patch related to this issue.
It has been pushed to "libreoffice-24-2":

https://git.libreoffice.org/help/commit/d25d6d02f06138274426492ef11f35409966e829

tdf#156156: add Animation sidebar deck help button's HID